"""
    Open:Risk API

    Service to calculate parametric linear risk statistics and generate risk model asset identifier mappings.  # noqa: E501

    The version of the OpenAPI document: 1.23.0
    Contact: ParametricRiskAnalyticsDevelopment@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.OpenRisk.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.OpenRisk.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.OpenRisk.model.currency_iso_code import CurrencyISOCode
    from fds.sdk.OpenRisk.model.inline_response2002_data_factors import InlineResponse2002DataFactors
    from fds.sdk.OpenRisk.model.inline_response2002_data_risk_model_append_format import InlineResponse2002DataRiskModelAppendFormat
    from fds.sdk.OpenRisk.model.risk_model_code import RiskModelCode
    globals()['CurrencyISOCode'] = CurrencyISOCode
    globals()['InlineResponse2002DataFactors'] = InlineResponse2002DataFactors
    globals()['InlineResponse2002DataRiskModelAppendFormat'] = InlineResponse2002DataRiskModelAppendFormat
    globals()['RiskModelCode'] = RiskModelCode


class InlineResponse2002Data(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('currencies',): {
            'min_items': 1,
        },
        ('factors',): {
            'min_items': 1,
        },
        ('frequency',): {
            'min_length': 1,
        },
        ('name',): {
            'min_length': 1,
        },
        ('vendor',): {
            'min_length': 1,
        },
        ('risk_model_append_format',): {
            'min_items': 1,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'code': (RiskModelCode,),  # noqa: E501
            'currencies': ([CurrencyISOCode],),  # noqa: E501
            'currency': (CurrencyISOCode,),  # noqa: E501
            'factors': ([InlineResponse2002DataFactors],),  # noqa: E501
            'factor_id_to_iso_currency': ({str: (CurrencyISOCode,)},),  # noqa: E501
            'first_date': (date,),  # noqa: E501
            'frequency': (str,),  # noqa: E501
            'latest_date': (date,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'universe_count': (int,),  # noqa: E501
            'vendor': (str,),  # noqa: E501
            'risk_model_append_format': ([InlineResponse2002DataRiskModelAppendFormat],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'code': 'code',  # noqa: E501
        'currencies': 'currencies',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'factors': 'factors',  # noqa: E501
        'factor_id_to_iso_currency': 'factorIdToIsoCurrency',  # noqa: E501
        'first_date': 'firstDate',  # noqa: E501
        'frequency': 'frequency',  # noqa: E501
        'latest_date': 'latestDate',  # noqa: E501
        'name': 'name',  # noqa: E501
        'universe_count': 'universeCount',  # noqa: E501
        'vendor': 'vendor',  # noqa: E501
        'risk_model_append_format': 'riskModelAppendFormat',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, code, currencies, currency, factors, factor_id_to_iso_currency, first_date, frequency, latest_date, name, universe_count, vendor, *args, **kwargs):  # noqa: E501
        """InlineResponse2002Data - a model defined in OpenAPI

        Args:
            code (RiskModelCode):
            currencies ([CurrencyISOCode]): Currencies that can be used with the model
            currency (CurrencyISOCode):
            factors ([InlineResponse2002DataFactors]): Factors of the model
            factor_id_to_iso_currency ({str: (CurrencyISOCode,)}): Map of currency factor IDs to ISO currency code.
            first_date (date): **(since 1.12.0)**  Date format YYYY-MM-DD.
            frequency (str): Frequency of the model
            latest_date (date): **(since 1.12.0)**  Date format YYYY-MM-DD.
            name (str): Model name
            universe_count (int): Total universe count of the model
            vendor (str): Model vendor

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            risk_model_append_format ([InlineResponse2002DataRiskModelAppendFormat]): List of fields which are supported by the risk model for appending additional asset data. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.code = code
        self.currencies = currencies
        self.currency = currency
        self.factors = factors
        self.factor_id_to_iso_currency = factor_id_to_iso_currency
        self.first_date = first_date
        self.frequency = frequency
        self.latest_date = latest_date
        self.name = name
        self.universe_count = universe_count
        self.vendor = vendor
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, code, currencies, currency, factors, factor_id_to_iso_currency, first_date, frequency, latest_date, name, universe_count, vendor, *args, **kwargs):  # noqa: E501
        """InlineResponse2002Data - a model defined in OpenAPI

        Args:
            code (RiskModelCode):
            currencies ([CurrencyISOCode]): Currencies that can be used with the model
            currency (CurrencyISOCode):
            factors ([InlineResponse2002DataFactors]): Factors of the model
            factor_id_to_iso_currency ({str: (CurrencyISOCode,)}): Map of currency factor IDs to ISO currency code.
            first_date (date): **(since 1.12.0)**  Date format YYYY-MM-DD.
            frequency (str): Frequency of the model
            latest_date (date): **(since 1.12.0)**  Date format YYYY-MM-DD.
            name (str): Model name
            universe_count (int): Total universe count of the model
            vendor (str): Model vendor

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            risk_model_append_format ([InlineResponse2002DataRiskModelAppendFormat]): List of fields which are supported by the risk model for appending additional asset data. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.code = code
        self.currencies = currencies
        self.currency = currency
        self.factors = factors
        self.factor_id_to_iso_currency = factor_id_to_iso_currency
        self.first_date = first_date
        self.frequency = frequency
        self.latest_date = latest_date
        self.name = name
        self.universe_count = universe_count
        self.vendor = vendor
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
